   1 REM   GarageBEEP 3 - Copyright (c) 2008-2009 Andrew Owen.

   2 REM : INT+ x,y,view,end,record,loop,octave,period,tempo,s(),v,n,i
   3 REM : INT n(),t(),pitch,note
   4 REM : OPEN # 

   5 IF PEEK 56811=0 THEN GO TO 15: REM Define note array including all 18 keyboard keys for each octave. Note: in octave 11 some keys repeat to avoid out of range values

   6 DIM n(11,18)
   7 FOR x=1 TO 11: FOR y=1 TO 18: LET n(x,y)=x*12+y-73: NEXT y: NEXT x
   8 FOR x=11 TO 18: LET n(11,x)=69: NEXT x

   9 DIM s(25,3): RESTORE 9990: FOR x=1 TO 25: FOR y=1 TO 3: READ a: LET s(x,y)=a: NEXT y: NEXT x: REM Define display data array for printing notes

  10 DIM t(2,1055): REM clear tune array (over-length to prevent stave drawing error)
  
  11 REM define initial values

  12 LET view=5: LET note=1: LET end=128: LET record=0: LET loop=0
  13 LET octave=6: LET period=4: LET tempo=120

  14 REM editor

  15 BORDER 2: INK 0: POKE 58620,27: RANDOMIZE USR 58612
  16 POKE 23038,56+(record*2): POKE 23133,56+(loop*5)
  17 GO SUB 1250: GO SUB 1380: GO SUB 1580: GO SUB 6000

 200 PAUSE 5
 205 LET i$=INKEY$
 210 IF i$="" THEN GO TO 200

 250 REM keyboard notes
 260 IF i$="a" THEN LET pitch=n(octave,1): GO SUB 900
 270 IF i$="w" THEN LET pitch=n(octave,2): GO SUB 900
 280 IF i$="s" THEN LET pitch=n(octave,3): GO SUB 900
 290 IF i$="e" THEN LET pitch=n(octave,4): GO SUB 900
 300 IF i$="d" THEN LET pitch=n(octave,5): GO SUB 900
 310 IF i$="f" THEN LET pitch=n(octave,6): GO SUB 900
 320 IF i$="t" THEN LET pitch=n(octave,7): GO SUB 900
 330 IF i$="g" THEN LET pitch=n(octave,8): GO SUB 900
 340 IF i$="y" THEN LET pitch=n(octave,9): GO SUB 900
 350 IF i$="h" THEN LET pitch=n(octave,10): GO SUB 900
 360 IF i$="u" THEN LET pitch=n(octave,11): GO SUB 900
 370 IF i$="j" THEN LET pitch=n(octave,12): GO SUB 900
 390 IF i$="k" THEN LET pitch=n(octave,13): GO SUB 900
 400 IF i$="o" THEN LET pitch=n(octave,14): GO SUB 900
 410 IF i$="l" THEN LET pitch=n(octave,15): GO SUB 900
 420 IF i$="p" THEN LET pitch=n(octave,16): GO SUB 900
 430 IF i$=";" THEN LET pitch=n(octave,17): GO SUB 900
 440 IF i$="'" THEN LET pitch=n(octave,18): GO SUB 900

 450 REM change octave
 460 IF i$="z" THEN GO SUB 1100
 470 IF i$="x" THEN GO SUB 1200

 500 REM change period
 510 IF i$="c" THEN GO SUB 1300
 520 IF i$="v" THEN GO SUB 1350

 550 REM change tempo
 560 IF i$="," THEN GO SUB 1500
 570 IF i$="." THEN GO SUB 1550

 600 REM change view
 610 IF i$="1" THEN GO SUB 1600
 620 IF i$="2" THEN GO SUB 1650

 650 REM change note
 660 IF i$="3" THEN GO SUB 1700
 670 IF i$="4" THEN GO SUB 1750

 700 REM change end
 710 IF i$="9" THEN GO SUB 1800
 720 IF i$="0" THEN GO SUB 1850

 725 REM play current note
 726 IF i$="b" THEN GO SUB 800

 727 REM record on/off
 728 IF i$=CHR$ 13 AND record=0 THEN LET record=1: POKE 23038,58: GO TO 200
 729 IF i$=CHR$ 13 AND record=1 THEN LET record=0: POKE 23038,56: GO TO 200

 730 REM loop on/off
 731 IF i$=CHR$ 10 AND loop=0 THEN LET loop=1: POKE 23133,61: GO TO 200
 732 IF i$=CHR$ 10 AND loop=1 THEN LET loop=0: POKE 23133,56: GO TO 200

 733 REM back to start
 734 IF i$=CHR$ 11 THEN LET note=1: GO SUB 1700

 735 REM back 32 notes
 736 IF i$=CHR$ 8 THEN LET note=note-31: GO SUB 1700

 737 REM forward 32 notes
 738 IF i$=CHR$ 9 THEN LET note=note+31: GO SUB 1750

 739 REM switch to file menu
 740 IF i$="m" THEN GO TO 2000

 741 REM clear note
 742 IF i$="n" THEN LET t(1,note)=0:LET t(2,note)=0:GO TO 17

 797 REM playback
 798 IF i$=" " THEN GO TO 3000

 799 GO TO 200

 800 REM play note
 805 IF t(2,note)=0 THEN GO TO 1020
 810 BEEP 240/(tempo*t(2,note)),t(1,note)
 820 GO TO 1020

 900 REM play note (freeplay)
 910 BEEP 240/(tempo*period),pitch
 920 IF record=0 THEN RETURN

1000 REM record note
1001 LET t(1,note)=pitch
1002 LET t(2,note)=period
1020 LET note=note+1
1030 IF note=end+1 THEN LET note=end
1040 GO TO 1780

1100 REM octave down
1110 PRINT OVER 1; BRIGHT 1; PAPER 7;AT 1,octave*2.45;"   "
1120 PRINT OVER 1; BRIGHT 1; PAPER 7;AT 2,octave*2.45;"   "
1130 LET octave=octave-1
1140 IF octave=0 THEN LET octave=1
1150 GO TO 1250

1200 REM octave up
1210 PRINT OVER 1; BRIGHT 1; PAPER 7;AT 1,octave*2.45;"   "
1220 PRINT OVER 1; BRIGHT 1; PAPER 7;AT 2,octave*2.45;"   "
1230 LET octave=octave+1
1240 IF octave=12 THEN LET octave=11
1250 PRINT OVER 1; BRIGHT 1; PAPER 5;AT 1,octave*2.45;"   "
1260 PRINT OVER 1; BRIGHT 1; PAPER 5;AT 2,octave*2.45;"   "
1270 PRINT #0; INK 0; PAPER 7;AT 0,4;" ";AT 0,2;"C";octave-4
1280 RETURN

1300 REM period down
1310 LET period=period*2
1320 IF period=256 THEN LET period=128
1330 GO TO 1380

1350 REM period up
1360 LET period=period/2
1370 IF period<1 THEN LET period=1
1380 PRINT #0;AT 0,14;
1390 IF period=1 THEN PRINT #0; INK 0; PAPER 7;" 1   "
1400 IF period=2 THEN PRINT #0; INK 0; PAPER 7;" 1/2 "
1410 IF period=4 THEN PRINT #0; INK 0; PAPER 7;" 1/4 "
1420 IF period=8 THEN PRINT #0; INK 0; PAPER 7;" 1/8 "
1430 IF period=16 THEN PRINT #0; INK 0; PAPER 7;" 1/16"
1440 IF period=32 THEN PRINT #0; INK 0; PAPER 7;" 1/32"
1450 IF period=64 THEN PRINT #0; INK 0; PAPER 7;" 1/64"
1460 IF period=128 THEN PRINT #0; INK 0; PAPER 7;"1/128"
1470 RETURN

1500 REM tempo down
1510 LET tempo=tempo-1
1520 IF tempo=39 THEN LET tempo=40
1530 GO TO 1580

1550 REM tempo up
1560 LET tempo=tempo+1
1570 IF tempo=241 THEN LET tempo=240
1580 PRINT #0; INK 0; PAPER 7;AT 0,25;tempo;"  "
1590 RETURN

1600 REM view down
1610 LET view=view-1
1620 IF view=0 THEN LET view=1
1630 GO TO 1680

1650 REM view up
1660 LET view=view+1
1670 IF view=11 THEN LET view=10
1680 GO SUB 6000
1690 RETURN

1700 REM note down
1710 LET note=note-1
1720 IF note<1 THEN LET note=1
1730 GO TO 1780

1750 REM note up
1760 LET note=note+1
1770 IF note>end THEN LET note=end
1780 GO SUB 6000
1790 RETURN

1800 REM end down
1810 LET end=end-1
1820 IF end=0 THEN LET end=1
1830 GO TO 1880

1850 REM end up
1860 LET end=end+1
1870 IF end=1025 THEN LET end=1024
1880 PRINT AT 15,26;"   ";AT 15,25;end
1890 RETURN


2000 REM file menu
2001 PRINT AT 14,0; INK 7; PAPER 2;,,"GarageBEEP","3.0.1 (001.02)","Copyright ";CHR$ 127;"2008-2009 Andrew Owen",,"1 - LOAD TUNE","4 - CLEAR TUNE","2 - SAVE TUNE","5 - EXIT MENU","3 - EXPORT TUNE",,,,
2002 PLOT 0,63: DRAW 255,0:
2003 INPUT i
2004 IF i=1 THEN POKE 56811,1 : STOP
2005 IF i=2 THEN POKE 56811,2 : STOP
2006 IF i=3 THEN POKE 56811,3 : STOP
2007 IF i=4 THEN GO TO 9
2008 IF i=5 THEN GO TO 15
2009 GO TO 2003


3000 REM playback
3010 POKE 23197,61
3020 IF t(2,note)=0 THEN GO TO 3030
3025 BEEP 240/(tempo*t(2,note)),t(1,note)
3030 LET note=note+1
3040 IF note>end AND loop=0 THEN LET note=end: POKE 23197,56:GO TO 17
3050 IF note>end THEN LET note=1
3060 IF INKEY$=" " THEN POKE 23197,56:GO TO 17
3070 GO TO 3020


6000 REM display notes
6010 POKE 58620,16: REM just clear the stave
6020 RANDOMIZE USR 58612
6030 PRINT AT 15,2;" ";AT 15,0;"C";view-4
6040 PRINT AT 15,14;"   ";AT 15,13;note
6050 PRINT AT 15,26;"   ";AT 15,25;end
6060 LET a=73-view*12
6070 FOR x=1 TO 31
6071 IF t(2,note+x-1)=0 THEN GO TO 6110
6080 LET n=t(1,note+x-1)+a
6090 LET v=256-t(2,note+x-1)
6100 IF n>=1 AND n<=25 THEN POKE s(n,1)+x,v: POKE s(n,2)+x,v: POKE s(n,3)+x,v
6110 NEXT x
6120 RETURN


9985 REM loader - starts here on first run

9986 REM BORDER 7: POKE 23693,63: REM CLEAR 58611
9987 REM LOAD "loading" SCREEN$: PRINT AT 0,0;
9988 REM LOAD "editor" CODE 58612,6924: INK 0
9989 REM GO TO 1

9990 REM note display data

9991 DATA 19872,20128,20384,19104,19360,19616,20352,18592,18848
9992 DATA 19584,19840,20096,18816,19072,19328,19808,20064,20320
9993 DATA 19040,19296,19552,20288,18528,18784,19520,19776,20032
9994 DATA 18752,19008,19264,20000,20256,18496,19232,19488,19744
9995 DATA 20224,18464,18720,19456,19712,19968,18688,18944,19200
9996 DATA 18144,18400,18432,17376,17632,17888,18368,16608,16864
9997 DATA 17600,17856,18112,16832,17088,17344,18080,18336,16576
9998 DATA 17312,17568,17824,16544,16800,17056,17792,18048,18304
9999 DATA 16768,17024,17280